//+------------------------------------------------------------------+
//|                                            Trend_way_Pending.mq4 |
//|                                                Apostol-Aristotel |
//|                                  http://www.apostol-aristotel.ru |
//+------------------------------------------------------------------+
#property copyright "Apostol-Aristotel"
#property link      "http://www.apostol-aristotel.ru"
extern int TakeProfit=30;
extern int StopLoss=30;
extern int padding=50;
extern int Pending=1;
extern int Magic=678; // Magic    
int ticketB, ticketS, modify, Sell_Orders, Buy_Orders, Pending_Orders, sl; // Modify-   , 1 - , 0 - . ticetB -      , ticketS -  .
 // sl -  ,  .  = . 
extern double Lots;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
    if(OrdersTotal()==0)
     {
      Sell_Orders=0;
      Buy_Orders=0;
      Pending_Orders=0;
      Lots=0;
      modify=0;
     }
    for (int i=1; i<=OrdersTotal(); i++)       //   ,..
     {                                         //  
      if(OrderSelect(i-1,SELECT_BY_POS)==true) //  
        {
         sl=MarketInfo(Symbol(),MODE_STOPLEVEL);   //                                         
         if(OrderType()==OP_BUY)
          {
           if(modify==0)
            {
             OrderModify(OrderTicket(),0,OrderOpenPrice()-Point*StopLoss,OrderOpenPrice()+Point*TakeProfit,0,Blue); //  (   )      
             modify++;
             Buy_Orders++;
             Lots=OrderLots();
            }
           if(Bid>sl*Point+OrderOpenPrice())                              //    
            OrderModify(OrderTicket(),0,Bid-Point*sl,OrderTakeProfit(),0,Blue); //  
           if(OrderTakeProfit()==Bid || OrderStopLoss()>OrderOpenPrice())                    //       
            {
             if(OP_SELLSTOP==1)                                        //     
              OrderDelete(ticketS);                                    //  
            }
          }
         if(OrderType()==OP_SELL)
          {
           if(modify==0)
            {
             OrderModify(OrderTicket(),0,OrderOpenPrice()+Point*StopLoss,OrderOpenPrice()-Point*TakeProfit,0,Blue); //  (   )      
             modify++;
             Sell_Orders++;
             Lots=OrderLots();
            }
           if(Ask<OrderOpenPrice()-sl*Point)                               //    
             OrderModify(OrderTicket(),0,Ask+Point*sl,OrderTakeProfit(),0,Blue); //  
           if(OrderTakeProfit()==Ask || OrderStopLoss()<OrderOpenPrice())                    //         
            {
             if(OP_BUYSTOP==1)                                             //     
              OrderDelete(ticketB);                                      //  
            }
          }
         if((OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) && OrderMagicNumber()==Magic && Pending_Orders<2  && Pending==1) //       1  
           Pending_Orders++;
        }
     } 

     if(Pending_Orders==0 && Pending==1) //       
      {
       if(Sell_Orders==1) //     
        {
         ticketB++;
         OrderSend(Symbol(),OP_BUYSTOP,2*Lots,Ask+padding*Point,3,Bid-2*StopLoss*Point+padding*Point,Bid+0.5*TakeProfit*Point+padding*Point,"My order #"+ticketB,Magic,0,Green); //   
        }
       if(Buy_Orders==1)  //     
        {
         ticketS++;
         OrderSend(Symbol(),OP_SELLSTOP,2*Lots,Bid-padding*Point,3,Ask+2*StopLoss*Point-padding*Point,Ask-0.5*TakeProfit*Point-padding*Point,"My order #"+ticketS,Magic,0,Green); //   
        }
      }
      
      if(OrderType()==OP_BUYSTOP && Pending==1) //     
       {
        if(OrderSelect(ticketB, SELECT_BY_TICKET)==true)  //    
         {
          if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && Bid-Point*sl>OrderOpenPrice()) //    =  ,    ,   . 
           if(Bid-Point*sl>OrderStopLoss()) OrderModify(OrderTicket(),0,Bid-Point*sl,OrderTakeProfit(),0,Blue); //      ,   
         }
       }
       if(OrderType()==OP_SELLSTOP  && Pending==1)//     
       {
        if(OrderSelect(ticketS, SELECT_BY_TICKET)==true)  //    
         {
          if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic && Ask+Point*sl<OrderOpenPrice()) //    =  ,    ,   . 
           if(Bid-Point*sl>OrderStopLoss()) OrderModify(OrderTicket(),0,Ask+Point*sl,OrderTakeProfit(),0,Blue); //      ,   
         }
       }
//----
   return(0);
  }
//+------------------------------------------------------------------+